Namespaces
Variants
Views
Actions

std::system_error::system_error

From cppreference.com
< cpp‎ | error‎ | system error
 
 
Utilities library
General utilities
Date and time
Function objects
Formatting library (C++20)
(C++11)
Relational operators (deprecated in C++20)
Integer comparison functions
(C++20)
Swap and type operations
(C++14)
(C++11)
(C++11)
(C++11)
(C++17)
Common vocabulary types
(C++11)
(C++17)
(C++17)
(C++17)
(C++17)

Elementary string conversions
(C++17)
(C++17)
 
 
 
system_error( std::error_code ec );
(1) (since C++11)
system_error( std::error_code ec, const std::string& what_arg );
(2) (since C++11)
system_error( std::error_code ec, const char* what_arg );
(2) (since C++11)
system_error( int ev, const std::error_category& ecat );
(3) (since C++11)
system_error( int ev, const std::error_category& ecat,
              const std::string& what_arg );
(4) (since C++11)
system_error( int ev, const std::error_category& ecat,
              const char* what_arg );
(4) (since C++11)
system_error( const system_error& other ) noexcept;
(5) (since C++11)

Constructs new system error object.

1) Constructs with error code ec
2) Constructs with error code ec and explanation string what_arg. The string returned by what() is guaranteed to contain what_arg as a substring.
3) Constructs with underlying error code ev and associated error category ecat.
4) Constructs with underlying error code ev, associated error category ecat and explanatory string what_arg. The string returned by what() is guaranteed to contain what_arg as a substring (assuming that it doesn't contain an embedded null character ).
5) Copy constructor. Initializes the contents with those of other. If *this and other both have dynamic type std::system_error then std::strcmp(what(), other.what()) == 0.

[edit] Parameters

ec - error code
ev - underlying error code in the enumeration associated with ecat
ecat - the category of error
what_arg - explanatory string
other - another system_error to copy

[edit] Example

Demonstrates how to create a system_error exception from an errno value.

#include <iostream>
#include <system_error>
 
int main()
{
    try
    {
        throw std::system_error(EDOM, std::generic_category(), "hello world");
    }
    catch (const std::system_error& ex)
    {
        std::cout << ex.code() << '\n';
        std::cout << ex.code().message() << '\n';
        std::cout << ex.what() << '\n';
    }
}

Possible output:

generic:33
Numerical argument out of domain
hello world: Numerical argument out of domain